/*
 * generated by Xtext 2.16.0
 */
package org.xtext.ungs.drake.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.xtext.ungs.drake.drake.DrakePackage;
import org.xtext.ungs.drake.drake.Element;
import org.xtext.ungs.drake.drake.Factor;
import org.xtext.ungs.drake.drake.Formulation;
import org.xtext.ungs.drake.drake.LinearExpression;
import org.xtext.ungs.drake.drake.LinearInequation;
import org.xtext.ungs.drake.drake.Model;
import org.xtext.ungs.drake.drake.Tuple;
import org.xtext.ungs.drake.drake.Variable;
import org.xtext.ungs.drake.services.DrakeGrammarAccess;

@SuppressWarnings("all")
public class DrakeSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DrakeGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == DrakePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case DrakePackage.ELEMENT:
				sequence_Element(context, (Element) semanticObject); 
				return; 
			case DrakePackage.FACTOR:
				sequence_Factor(context, (Factor) semanticObject); 
				return; 
			case DrakePackage.FORMULATION:
				sequence_Formulation(context, (Formulation) semanticObject); 
				return; 
			case DrakePackage.LINEAR_EXPRESSION:
				sequence_LinearExpression(context, (LinearExpression) semanticObject); 
				return; 
			case DrakePackage.LINEAR_INEQUATION:
				sequence_LinearInequation(context, (LinearInequation) semanticObject); 
				return; 
			case DrakePackage.MODEL:
				sequence_Model(context, (Model) semanticObject); 
				return; 
			case DrakePackage.SET:
				sequence_Set(context, (org.xtext.ungs.drake.drake.Set) semanticObject); 
				return; 
			case DrakePackage.TUPLE:
				sequence_Tuple(context, (Tuple) semanticObject); 
				return; 
			case DrakePackage.VARIABLE:
				sequence_Variable(context, (Variable) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Element returns Element
	 *
	 * Constraint:
	 *     (value=INT | string=STRING | variable=Variable | tuple=Tuple)
	 */
	protected void sequence_Element(ISerializationContext context, Element semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Factor returns Factor
	 *
	 * Constraint:
	 *     ((value=INT simbolo='*' variable=Variable) | (variable=Variable simbolo='*' value=INT) | variable=Variable)
	 */
	protected void sequence_Factor(ISerializationContext context, Factor semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Formulation returns Formulation
	 *
	 * Constraint:
	 *     (definitions+=Set* (function='max' | function='min') expression=LinearExpression inequation+=LinearInequation inequation+=LinearInequation*)
	 */
	protected void sequence_Formulation(ISerializationContext context, Formulation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     LinearExpression returns LinearExpression
	 *
	 * Constraint:
	 *     ((factor=Factor ((simbol='+' | simbol='-') expression=LinearExpression)?) | value=INT)
	 */
	protected void sequence_LinearExpression(ISerializationContext context, LinearExpression semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     LinearInequation returns LinearInequation
	 *
	 * Constraint:
	 *     (linearExpression=LinearExpression simbol=SIMBOL (varInequality=Variable | intInequality=INT))
	 */
	protected void sequence_LinearInequation(ISerializationContext context, LinearInequation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Model returns Model
	 *
	 * Constraint:
	 *     formulation+=Formulation+
	 */
	protected void sequence_Model(ISerializationContext context, Model semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Set returns Set
	 *
	 * Constraint:
	 *     (name=ID ((elements+=Tuple elements+=Tuple*)+ | (lowerBound=INT upperBound=INT))?)
	 */
	protected void sequence_Set(ISerializationContext context, org.xtext.ungs.drake.drake.Set semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Tuple returns Tuple
	 *
	 * Constraint:
	 *     (elements+=Element elements+=Element*)*
	 */
	protected void sequence_Tuple(ISerializationContext context, Tuple semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Variable returns Variable
	 *
	 * Constraint:
	 *     (name=ID (index+=INT | (index+=INT index+=INT?))?)
	 */
	protected void sequence_Variable(ISerializationContext context, Variable semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
